#include "chdecl.h"
void CH_type_literalcheck(current, sched, cop)
#define ARGUMENTS 8
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb2;
    case 2: goto c3;
    case 3: goto cb10;
    case 4: goto c11;
    case 5: goto c14;
    case 6: goto cb15;
    case 7: goto c16;
    case 8: goto c27;
    case 9: goto c28;
    case 10: goto cb30;
    case 11: goto c31;
    case 12: goto c33;
    case 13: goto c34;
    case 14: goto c38;
    case 15: goto c39;
    case 16: goto c41;
    case 17: goto c72;
    case 18: goto c97;
    case 19: goto c100;
    case 20: goto c103;
    case 21: goto c109;
    case 22: goto c129;
    case 23: goto c132;
    case 24: goto c137;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb2:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c3:
/* reveal 3.0.3 , 10 */
  if (10 != REF(3)DOT(0)DOT(3).value.variant->info.variant_case)
     goto ch_case_error;
/* initget 4 3.0.2 , 0,0 */
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(4),DEF(3)DOT(0)DOT(2),nil,sched,GET,
    0,0)) != Normal) goto ch_raise_exception;
/* get_or_err 4 3.0.2 */
  if ((ch_returncode = get_selected_object(DEF(4),DEF(3)DOT(0)DOT(2)
    ,sched)) != Normal) goto ch_raise_exception;
/* copy 5 4 */
  if((ch_returncode = (REF(4).tsdr->copy)(& ch_val, REF(4).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).value = ch_val;
  REF(5).tsdr = datarepmap[REF(4).tsdr->number];
/* endget 4 3.0.2 */
  end_selector(DEF(4),DEF(3)DOT(0)DOT(2),sched,GET);
/* move 6 5 */
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  REF(6) = REF(5);
  REF(5).tsdr = & dr_bottom;
/* block , 2 */
  if((ch_returncode = che_block(QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 3;
cb10:
/* call 3.6 6 3.2 3.3 3.4 7 , 3 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(6),
          arguments[1] = DEF(6),
          arguments[2] = DEF(3)DOT(2),
          arguments[3] = DEF(3)DOT(3),
          arguments[4] = DEF(3)DOT(4),
          arguments[5] = DEF(7),
          arguments[5+1] = nil,& arguments[0]),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
  return;
c11:
/* move 8 7 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8) = REF(7);
  REF(7).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 15 */
   goto c15;
c14:
/* exit , 4 */
  ch_e = handler_type__exit; ch_val = QUAL(4); goto ch_exception;
c15:
  current->ip = 6;
cb15:
/* call 3.7 8 3.3 9 , 5 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(7),
          arguments[1] = DEF(8),
          arguments[2] = DEF(3)DOT(3),
          arguments[3] = DEF(9),
          arguments[3+1] = nil,& arguments[0]),QUAL(5),sched)) != Normal)
     goto ch_raise_exception;
  return;
c16:
/* move 10 9 */
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10) = REF(9);
  REF(9).tsdr = & dr_bottom;
/* equal . 3.0.1 =(64) , 23 */
  if ( REF(3)DOT(0)DOT(1).value.ord_enum == 64 ) goto c23;
/* equal . 3.0.1 =(44) , 72 */
  if ( REF(3)DOT(0)DOT(1).value.ord_enum == 44 ) goto c72;
/* branch , 97 */
   goto c97;
c23:
/* block , 6 */
  if((ch_returncode = che_block(QUAL(6),sched)) != Normal)
     goto ch_raise_exception;
/* reveal 10.2 , 7 */
  if (7 != REF(10)DOT(2).value.variant->info.variant_case) goto ch_case_error;
/* endblock */
  che_endblock(sched);
/* branch , 28 */
   goto c28;
c27:
/* exit , 4 */
  ch_e = handler_type__exit; ch_val = QUAL(4); goto ch_exception;
c28:
/* branch_false 10.2.0.0 , 33 */
  if ( !REF(10)DOT(2)DOT(0)DOT(0).value.boolean ) goto c33;
/* copy 8 10.2.0.2 */
  if((ch_returncode = (REF(10)DOT(2)DOT(0)DOT(2).tsdr->copy)(& ch_val, 
    REF(10)DOT(2)DOT(0)DOT(2).value)) != Normal) goto ch_raise_exception;
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).value = ch_val;
  REF(8).tsdr = datarepmap[REF(10)DOT(2)DOT(0)DOT(2).tsdr->number];
  current->ip = 10;
cb30:
/* call 3.7 8 3.3 11 , 5 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(7),
          arguments[1] = DEF(8),
          arguments[2] = DEF(3)DOT(3),
          arguments[3] = DEF(11),
          arguments[3+1] = nil,& arguments[0]),QUAL(5),sched)) != Normal)
     goto ch_raise_exception;
  return;
c31:
/* move 10 11 */
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10) = REF(11);
  REF(11).tsdr = & dr_bottom;
/* branch , 34 */
   goto c34;
c33:
/* exit , 4 */
  ch_e = handler_type__exit; ch_val = QUAL(4); goto ch_exception;
c34:
/* block , 7 */
  if((ch_returncode = che_block(QUAL(7),sched)) != Normal)
     goto ch_raise_exception;
/* reveal 10.2 , 3 */
  if (3 != REF(10)DOT(2).value.variant->info.variant_case) goto ch_case_error;
/* endblock */
  che_endblock(sched);
/* branch , 39 */
   goto c39;
c38:
/* exit , 4 */
  ch_e = handler_type__exit; ch_val = QUAL(4); goto ch_exception;
c39:
/* copy 12 3.0.3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0)DOT(3)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).value = ch_val;
  REF(12).tsdr = & dr_table;
/* initget 13 12 , 0,0 */
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(13),DEF(12),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c41:
/* get_or_goto 13 12 , 69 */
  if ((ch_returncode = get_selected_object(DEF(13),DEF(12),sched)) != Normal)
     goto c69;
/* new_table 14 , 8 */
  if ((ch_returncode = che_new_table(DEF(14),QUAL(8),sched)) != Normal) 
     goto ch_raise_exception;
/* copy 15 13 */
  if((ch_returncode = (REF(13).tsdr->copy)(& ch_val, REF(13).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).value = ch_val;
  REF(15).tsdr = datarepmap[REF(13).tsdr->number];
/* insert 14 15 */
  if ((ch_returncode = insertfunc(DEF(14),DEF(15),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* boolean 16 , FALSE */
  REF(16).value.boolean = FALSE;
  REF(16).tsdr = & dr_boolean;
/* find_or_goto 17 10.2.0.1 14 , 0,48 */
  if (findfunc(DEF(17),DEF(10)DOT(2)DOT(0)DOT(1),(
          arguments[0] = DEF(14),& arguments[0]),sched,0) == FAILURE) goto c48;
/* boolean 16 , TRUE */
  REF(16).value.boolean = TRUE;
  REF(16).tsdr = & dr_boolean;
c48:
/* not 18 16 */
  REF(18).value.boolean = !REF(16).value.boolean;
  REF(18).tsdr = & dr_boolean;
/* branch_false 18 , 67 */
  if ( !REF(18).value.boolean ) goto c67;
/* new_record 19 , 3 */
  if ((ch_val.record = new_record(3)) == nil) goto ch_depletion;
  (*(REF(19).tsdr)->finalize)(REF(19).value,F_DISCARD,sched);
  REF(19).value = ch_val; REF(19).tsdr = & dr_record;
/* ordenum_lit 19.1 , 5 */
  REF(19)DOT(1).value.ord_enum = 5;
  REF(19)DOT(1).tsdr = & dr_ord_enumeration;
/* new_record 20 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20).value = ch_val; REF(20).tsdr = & dr_record;
/* copy 20.0 3.1 */
  if((ch_returncode = (REF(3)DOT(1).tsdr->copy)(& ch_val, REF(3)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(20)DOT(0).tsdr)->finalize)(REF(20)DOT(0).value,F_DISCARD,sched);
  REF(20)DOT(0).value = ch_val;
  REF(20)DOT(0).tsdr = datarepmap[REF(3)DOT(1).tsdr->number];
/* copy 20.1 3.0.0 */
  if((ch_returncode = (REF(3)DOT(0)DOT(0).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(20)DOT(1).tsdr)->finalize)(REF(20)DOT(1).value,F_DISCARD,sched);
  REF(20)DOT(1).value = ch_val;
  REF(20)DOT(1).tsdr = datarepmap[REF(3)DOT(0)DOT(0).tsdr->number];
/* unite 19.0 20 , 0 */
  if ((ch_returncode = che_unite(DEF(19)DOT(0),DEF(20),sched,0)) != Normal)
     goto ch_raise_exception;
/* new_table 19.2 , 9 */
  if ((ch_returncode = che_new_table(DEF(19)DOT(2),QUAL(9),sched)) != Normal) 
     goto ch_raise_exception;
/* copy 21 8 */
  if((ch_returncode = (REF(8).tsdr->copy)(& ch_val, REF(8).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(21).tsdr)->finalize)(REF(21).value,F_DISCARD,sched);
  REF(21).value = ch_val;
  REF(21).tsdr = datarepmap[REF(8).tsdr->number];
/* unite 22 21 , 2 */
  if ((ch_returncode = che_unite(DEF(22),DEF(21),sched,2)) != Normal)
     goto ch_raise_exception;
/* insert 19.2 22 */
  if ((ch_returncode = insertfunc(DEF(19)DOT(2),DEF(22),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* unite 22 14 , 3 */
  if ((ch_returncode = che_unite(DEF(22),DEF(14),sched,3)) != Normal)
     goto ch_raise_exception;
/* insert 19.2 22 */
  if ((ch_returncode = insertfunc(DEF(19)DOT(2),DEF(22),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* insert 3.5 19 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(5),DEF(19),FALSE,0)) != Normal)
     goto ch_raise_exception;
c67:
/* discard 14 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).tsdr = & dr_bottom;
/* branch , 41 */
   goto c41;
c69:
/* endget 13 12 */
  end_selector(DEF(13),DEF(12),sched,GET);
/* discard 12 */
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).tsdr = & dr_bottom;
/* branch , 100 */
   goto c100;
c72:
/* ord_case 23 10.2 */
  REF(23).value.ord_enum = REF(10)DOT(2).value.variant->info.variant_case;
  REF(23).tsdr = & dr_ord_enumeration;
/* equal . 23 =(2) , 79 */
  if ( REF(23).value.ord_enum == 2 ) goto c79;
/* equal . 23 =(3) , 86 */
  if ( REF(23).value.ord_enum == 3 ) goto c86;
/* branch , 94 */
   goto c94;
c79:
/* reveal 10.2 , 2 */
  if (2 != REF(10)DOT(2).value.variant->info.variant_case) goto ch_case_error;
/* notequal 24 3.0.3.0 10.2.0.0 */
  REF(24).value.boolean = (!eq_table(REF(3)DOT(0)DOT(3)DOT(0).value,
    REF(10)DOT(2)DOT(0)DOT(0).value));
  REF(24).tsdr = & dr_boolean;
/* notequal 25 3.0.3.0 10.2.0.1 */
  REF(25).value.boolean = (!eq_table(REF(3)DOT(0)DOT(3)DOT(0).value,
    REF(10)DOT(2)DOT(0)DOT(1).value));
  REF(25).tsdr = & dr_boolean;
/* and 26 24 25 */
  REF(26).value.boolean = REF(24).value.boolean&REF(25).value.boolean;
  REF(26).tsdr = & dr_boolean;
/* branch_false 26 , 100 */
  if ( !REF(26).value.boolean ) goto c100;
/* exit , 10 */
  ch_e = handler_type__exit; ch_val = QUAL(10); goto ch_exception;
c86:
/* reveal 10.2 , 3 */
  if (3 != REF(10)DOT(2).value.variant->info.variant_case) goto ch_case_error;
/* boolean 27 , FALSE */
  REF(27).value.boolean = FALSE;
  REF(27).tsdr = & dr_boolean;
/* find_or_goto 28 10.2.0.1 3.0.3.0 , 0,90 */
  if (findfunc(DEF(28),DEF(10)DOT(2)DOT(0)DOT(1),(
          arguments[0] = DEF(3)DOT(0)DOT(3)DOT(0),& arguments[0]),sched,0
            ) == FAILURE) goto c90;
/* boolean 27 , TRUE */
  REF(27).value.boolean = TRUE;
  REF(27).tsdr = & dr_boolean;
c90:
/* not 29 27 */
  REF(29).value.boolean = !REF(27).value.boolean;
  REF(29).tsdr = & dr_boolean;
/* branch_false 29 , 100 */
  if ( !REF(29).value.boolean ) goto c100;
/* exit , 10 */
  ch_e = handler_type__exit; ch_val = QUAL(10); goto ch_exception;
c94:
/* exit , 4 */
  ch_e = handler_type__exit; ch_val = QUAL(4); goto ch_exception;
c97:
/* exit , 11 */
  ch_e = handler_type__exit; ch_val = QUAL(11); goto ch_exception;
c100:
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 132 */
   goto c132;
c103:
/* discard 8 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).tsdr = & dr_bottom;
/* discard 10 */
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10).tsdr = & dr_bottom;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* branch , 132 */
   goto c132;
c109:
/* new_record 19 , 3 */
  if ((ch_val.record = new_record(3)) == nil) goto ch_depletion;
  (*(REF(19).tsdr)->finalize)(REF(19).value,F_DISCARD,sched);
  REF(19).value = ch_val; REF(19).tsdr = & dr_record;
/* ordenum_lit 19.1 , 5 */
  REF(19)DOT(1).value.ord_enum = 5;
  REF(19)DOT(1).tsdr = & dr_ord_enumeration;
/* new_record 20 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20).value = ch_val; REF(20).tsdr = & dr_record;
/* copy 20.0 3.1 */
  if((ch_returncode = (REF(3)DOT(1).tsdr->copy)(& ch_val, REF(3)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(20)DOT(0).tsdr)->finalize)(REF(20)DOT(0).value,F_DISCARD,sched);
  REF(20)DOT(0).value = ch_val;
  REF(20)DOT(0).tsdr = datarepmap[REF(3)DOT(1).tsdr->number];
/* copy 20.1 3.0.0 */
  if((ch_returncode = (REF(3)DOT(0)DOT(0).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(20)DOT(1).tsdr)->finalize)(REF(20)DOT(1).value,F_DISCARD,sched);
  REF(20)DOT(1).value = ch_val;
  REF(20)DOT(1).tsdr = datarepmap[REF(3)DOT(0)DOT(0).tsdr->number];
/* unite 19.0 20 , 0 */
  if ((ch_returncode = che_unite(DEF(19)DOT(0),DEF(20),sched,0)) != Normal)
     goto ch_raise_exception;
/* new_table 19.2 , 9 */
  if ((ch_returncode = che_new_table(DEF(19)DOT(2),QUAL(9),sched)) != Normal) 
     goto ch_raise_exception;
/* unite 22 8 , 2 */
  if ((ch_returncode = che_unite(DEF(22),DEF(8),sched,2)) != Normal)
     goto ch_raise_exception;
/* insert 19.2 22 */
  if ((ch_returncode = insertfunc(DEF(19)DOT(2),DEF(22),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* copy 30 3.0.3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0)DOT(3)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(30).tsdr)->finalize)(REF(30).value,F_DISCARD,sched);
  REF(30).value = ch_val;
  REF(30).tsdr = & dr_table;
/* unite 22 30 , 3 */
  if ((ch_returncode = che_unite(DEF(22),DEF(30),sched,3)) != Normal)
     goto ch_raise_exception;
/* insert 19.2 22 */
  if ((ch_returncode = insertfunc(DEF(19)DOT(2),DEF(22),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* insert 3.5 19 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(5),DEF(19),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* branch , 132 */
   goto c132;
c129:
/* chs_lit 31 , "CantHappen happened in literalcheck!" */
  if( !chs_lit(DEF(31),"CantHappen happened in literalcheck!") )
     goto ch_depletion;
/* print 31 */
  re_print(stderr, 0, DEF(31)); fflush(stderr);
/* discard 31 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31).tsdr = & dr_bottom;
c132:
/* discard 3 */
  (*(REF(3).tsdr)->finalize)(REF(3).value,F_DISCARD,sched);
  REF(3).tsdr = & dr_bottom;
/* discard 8 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).tsdr = & dr_bottom;
/* discard 10 */
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c137:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
